Package org.jboss.resteasy.client.jaxrs.internal

## Class ClientConfiguration

- java.lang.Object
- - org.jboss.resteasy.client.jaxrs.internal.ClientConfiguration

- All Implemented Interfaces:
    `javax.ws.rs.core.Configurable<ClientConfiguration>`, `javax.ws.rs.core.Configuration`, `javax.ws.rs.ext.Providers`, `HeaderValueProcessor`

      public class ClientConfiguration
      extends Object
      implements javax.ws.rs.core.Configuration, javax.ws.rs.core.Configurable<ClientConfiguration>, javax.ws.rs.ext.Providers, HeaderValueProcessor

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected ResteasyProviderFactory` | `providerFactory` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ClientConfiguration​(ClientConfiguration parent)` |
    `ClientConfiguration​(ResteasyProviderFactory factory)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addHeaderDelegate​(Class<?> clazz, javax.ws.rs.ext.RuntimeDelegate.HeaderDelegate header)` |
    `Set<Class<?>>` | `getClasses()` |
    `javax.ws.rs.core.Configuration` | `getConfiguration()` |
    `<T> javax.ws.rs.ext.ContextResolver<T>` | `getContextResolver​(Class<T> contextType, javax.ws.rs.core.MediaType mediaType)` |
    `Map<Class<?>,​Integer>` | `getContracts​(Class<?> componentClass)` |
    `Set<javax.ws.rs.container.DynamicFeature>` | `getDynamicFeatures()` |
    `<T extends Throwable> javax.ws.rs.ext.ExceptionMapper<T>` | `getExceptionMapper​(Class<T> type)` |
    `Set<Object>` | `getInstances()` |
    `<T> javax.ws.rs.ext.MessageBodyReader<T>` | `getMessageBodyReader​(Class<T> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `<T> javax.ws.rs.ext.MessageBodyWriter<T>` | `getMessageBodyWriter​(Class<T> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `Map<String,​Object>` | `getMutableProperties()` |
    `javax.ws.rs.ext.ParamConverter` | `getParamConverter​(Class<?> clazz, Type genericType, Annotation[] annotations)` |
    `Map<String,​Object>` | `getProperties()` |
    `Object` | `getProperty​(String name)` |
    `Collection<String>` | `getPropertyNames()` |
    `protected ResteasyProviderFactory` | `getProviderFactory()` |
    `javax.ws.rs.ext.ReaderInterceptor[]` | `getReaderInterceptors​(Class declaring, AccessibleObject target)` |
    `javax.ws.rs.client.ClientRequestFilter[]` | `getRequestFilters​(Class declaring, AccessibleObject target)` |
    `javax.ws.rs.client.ClientResponseFilter[]` | `getResponseFilters​(Class declaring, AccessibleObject target)` |
    `javax.ws.rs.RuntimeType` | `getRuntimeType()` |
    `<I extends javax.ws.rs.client.RxInvoker<?>> javax.ws.rs.client.RxInvokerProvider<I>` | `getRxInvokerProvider​(Class<I> clazz)` |
    `javax.ws.rs.client.RxInvokerProvider<?>` | `getRxInvokerProviderFromReactiveClass​(Class<?> clazz)` |
    `javax.ws.rs.ext.WriterInterceptor[]` | `getWriterInterceptors​(Class declaring, AccessibleObject target)` |
    `boolean` | `isEnabled​(Class<? extends javax.ws.rs.core.Feature> featureClass)` |
    `boolean` | `isEnabled​(javax.ws.rs.core.Feature feature)` |
    `boolean` | `isReactive​(Class<?> clazz)` |
    `boolean` | `isRegistered​(Class<?> componentClass)` |
    `boolean` | `isRegistered​(Object component)` |
    `ClientConfiguration` | `property​(String name, Object value)` |
    `ClientConfiguration` | `register​(Class<?> providerClass)` |
    `ClientConfiguration` | `register​(Class<?> providerClass, int priority)` |
    `ClientConfiguration` | `register​(Class<?> componentClass, Class<?>... contracts)` |
    `ClientConfiguration` | `register​(Class<?> componentClass, Map<Class<?>,​Integer> contracts)` |
    `ClientConfiguration` | `register​(Object provider)` |
    `ClientConfiguration` | `register​(Object provider, int Priority)` |
    `ClientConfiguration` | `register​(Object component, Class<?>... contracts)` |
    `ClientConfiguration` | `register​(Object component, Map<Class<?>,​Integer> contracts)` |
    `void` | `setProperties​(Map<String,​Object> newProps)` |
    `String` | `toHeaderString​(Object object)` | Convert an object to a header string.
    `String` | `toString​(Object object)` |
    `String` | `toString​(Object object, Type type, Annotation[] annotations)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### providerFactory

          protected ResteasyProviderFactory providerFactory

  - ### Constructor Detail

    - #### ClientConfiguration

          public ClientConfiguration​(ResteasyProviderFactory factory)

    - #### ClientConfiguration

          public ClientConfiguration​(ClientConfiguration parent)

  - ### Method Detail

    - #### setProperties

          public void setProperties​(Map<String,​Object> newProps)

    - #### getProviderFactory

          protected ResteasyProviderFactory getProviderFactory()

    - #### getMutableProperties

          public Map<String,​Object> getMutableProperties()

    - #### toHeaderString

          public String toHeaderString​(Object object)

      Convert an object to a header string. First try StringConverter, then HeaderDelegate, then object.toString()
      Specified by:
        `toHeaderString` in interface `HeaderValueProcessor`
      Parameters:
        `object` - header object
      Returns:
        header string

    - #### getMessageBodyWriter

          public <T> javax.ws.rs.ext.MessageBodyWriter<T> getMessageBodyWriter​(Class<T> type,
                                                                               Type genericType,
                                                                               Annotation[] annotations,
                                                                               javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `getMessageBodyWriter` in interface `javax.ws.rs.ext.Providers`

    - #### getMessageBodyReader

          public <T> javax.ws.rs.ext.MessageBodyReader<T> getMessageBodyReader​(Class<T> type,
                                                                               Type genericType,
                                                                               Annotation[] annotations,
                                                                               javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `getMessageBodyReader` in interface `javax.ws.rs.ext.Providers`

    - #### getWriterInterceptors

          public javax.ws.rs.ext.WriterInterceptor[] getWriterInterceptors​(Class declaring,
                                                                           AccessibleObject target)

    - #### getReaderInterceptors

          public javax.ws.rs.ext.ReaderInterceptor[] getReaderInterceptors​(Class declaring,
                                                                           AccessibleObject target)

    - #### getRequestFilters

          public javax.ws.rs.client.ClientRequestFilter[] getRequestFilters​(Class declaring,
                                                                            AccessibleObject target)

    - #### getResponseFilters

          public javax.ws.rs.client.ClientResponseFilter[] getResponseFilters​(Class declaring,
                                                                              AccessibleObject target)

    - #### getDynamicFeatures

          public Set<javax.ws.rs.container.DynamicFeature> getDynamicFeatures()

    - #### getParamConverter

          public javax.ws.rs.ext.ParamConverter getParamConverter​(Class<?> clazz,
                                                                  Type genericType,
                                                                  Annotation[] annotations)

    - #### toString

          public String toString​(Object object)

    - #### toString

          public String toString​(Object object,
                                 Type type,
                                 Annotation[] annotations)

    - #### getExceptionMapper

          public <T extends Throwable> javax.ws.rs.ext.ExceptionMapper<T> getExceptionMapper​(Class<T> type)

      Specified by:
        `getExceptionMapper` in interface `javax.ws.rs.ext.Providers`

    - #### getContextResolver

          public <T> javax.ws.rs.ext.ContextResolver<T> getContextResolver​(Class<T> contextType,
                                                                           javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `getContextResolver` in interface `javax.ws.rs.ext.Providers`

    - #### getProperties

          public Map<String,​Object> getProperties()

      Specified by:
        `getProperties` in interface `javax.ws.rs.core.Configuration`

    - #### getProperty

          public Object getProperty​(String name)

      Specified by:
        `getProperty` in interface `javax.ws.rs.core.Configuration`

    - #### getClasses

          public Set<Class<?>> getClasses()

      Specified by:
        `getClasses` in interface `javax.ws.rs.core.Configuration`

    - #### getInstances

          public Set<Object> getInstances()

      Specified by:
        `getInstances` in interface `javax.ws.rs.core.Configuration`

    - #### register

          public ClientConfiguration register​(Class<?> providerClass)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### register

          public ClientConfiguration register​(Object provider)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### register

          public ClientConfiguration register​(Class<?> providerClass,
                                              int priority)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### register

          public ClientConfiguration register​(Object provider,
                                              int Priority)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### property

          public ClientConfiguration property​(String name,
                                              Object value)

      Specified by:
        `property` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### getConfiguration

          public javax.ws.rs.core.Configuration getConfiguration()

      Specified by:
        `getConfiguration` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### register

          public ClientConfiguration register​(Class<?> componentClass,
                                              Class<?>... contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### register

          public ClientConfiguration register​(Class<?> componentClass,
                                              Map<Class<?>,​Integer> contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### register

          public ClientConfiguration register​(Object component,
                                              Class<?>... contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### register

          public ClientConfiguration register​(Object component,
                                              Map<Class<?>,​Integer> contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<ClientConfiguration>`

    - #### getRuntimeType

          public javax.ws.rs.RuntimeType getRuntimeType()

      Specified by:
        `getRuntimeType` in interface `javax.ws.rs.core.Configuration`

    - #### getPropertyNames

          public Collection<String> getPropertyNames()

      Specified by:
        `getPropertyNames` in interface `javax.ws.rs.core.Configuration`

    - #### isEnabled

          public boolean isEnabled​(javax.ws.rs.core.Feature feature)

      Specified by:
        `isEnabled` in interface `javax.ws.rs.core.Configuration`

    - #### isEnabled

          public boolean isEnabled​(Class<? extends javax.ws.rs.core.Feature> featureClass)

      Specified by:
        `isEnabled` in interface `javax.ws.rs.core.Configuration`

    - #### isRegistered

          public boolean isRegistered​(Object component)

      Specified by:
        `isRegistered` in interface `javax.ws.rs.core.Configuration`

    - #### isRegistered

          public boolean isRegistered​(Class<?> componentClass)

      Specified by:
        `isRegistered` in interface `javax.ws.rs.core.Configuration`

    - #### getContracts

          public Map<Class<?>,​Integer> getContracts​(Class<?> componentClass)

      Specified by:
        `getContracts` in interface `javax.ws.rs.core.Configuration`

    - #### getRxInvokerProvider

          public <I extends javax.ws.rs.client.RxInvoker<?>> javax.ws.rs.client.RxInvokerProvider<I> getRxInvokerProvider​(Class<I> clazz)

    - #### getRxInvokerProviderFromReactiveClass

          public javax.ws.rs.client.RxInvokerProvider<?> getRxInvokerProviderFromReactiveClass​(Class<?> clazz)

    - #### isReactive

          public boolean isReactive​(Class<?> clazz)

    - #### addHeaderDelegate

          public void addHeaderDelegate​(Class<?> clazz,
                                        javax.ws.rs.ext.RuntimeDelegate.HeaderDelegate header)